gMoreMenuMargin = 16
gMoreMenuStep = 4
gMoreMenuScreenWith = 288
gMoreMenuWidth = gMoreMenuScreenWith / gMoreMenuStep
gMapMessageBoxY = 15
gMapMessageBoxYwithStart = 37
gJunctionViewDirectory = "320_240_Lanes"
ETmcMapSize = {x = 44, y = 68, w = 232, h = 140}
SpeedlimitW = 41
SpeedlimitH = 51
USASpeedlimitW = 30
USASpeedlimitH = 40
SpeedcamW = 46
SpeedcamH = 35
SpeedcamSpeedlimitW = 41
SpeedcamSpeedlimitH = 53
rowShift = 16
picShift = 5
lineNumbers = 10
pictoSize = 18
tableHeight = 32
maxRowHeight = 132
frameH = 2
DAiconIdx = 0
TMCIconIndex = 0
SatAnimRadius = 22
 
sc_SpeedCam_SetMapCenter = function()
  local mapLayer = MODEL.map.primary
  mapLayer.center_posx = 16
  mapLayer.center_posy = 32
end
 
sc_mainmenu_set_smallmap = function()
  primary:X(23)
  primary:Y(28)
  primary:Z(40)
  primary:W(272)
  MODEL.map.primary.show_labels_3d = false
  MODEL.map.primary.show_labels_2d = false
  primary:SCALE(float.new("0.48"))
end
 
sc_set_smallmap_WhereAmI = function()
  primary:X(17)
  primary:Y(75)
  primary:Z(35)
  primary:W(286)
  primary:H(86)
end
 
sc_set_smallmap_ColorScheme = function()
  primary:X(14)
  primary:Y(48)
  primary:Z(35)
  primary:W(291)
  primary:H(134)
end
 
sc_routemenu_info_fit_open_from_main = function(topLeft, bottomRight)
  MODEL.map.primary.mode = "2d"
  MODEL.map.primary.fit.x = 53
  MODEL.map.primary.fit.y = 71
  if (not MODEL.lua.mainMenuMode() or not 208) and (vActiveState() ~= "st_easyroutemethod" or not 130) then
  end
  MODEL.map.primary.fit.w = 153
  MODEL.map.primary.fit.h = 115
  sc_fit_to_screen_delay(topLeft, bottomRight)
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_fit_to_screen_delay = function(topLeft, bottomRight)
  if topLeft == nil or bottomRight == nil then
    topLeft, bottomRight = MODEL.route.get_boundrect()
  end
  local globe = MODEL.BOOL.map.primary.fit.globe_enabled()
  MODEL.map.primary.fit.show(topLeft, bottomRight)
  MODEL.BOOL.map.primary.fit.globe_enabled = true
  MODEL.map.primary.fit.show(topLeft, bottomRight)
  MODEL.BOOL.map.primary.fit.globe_enabled = globe
end
 
sc_fit_resultpoi = function()
  local topLeft, bottomRight = MODEL.poi.resultpoi.get_boundingbox()
  sc_fit_general(topLeft, bottomRight, 53, 80, 213, 133)
  MODEL.lua.poiShowAllFlag = false
  MODEL.map.primary.show_cursor = false
  sc_SetPOICursorIcon()
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_fit_avoid = function(topLeft, bottomRight)
  sc_fit_general(topLeft, bottomRight, 53, 71, 213, 141)
end
 
sc_fit_traffic_detour = function(topLeft, bottomRight)
  sc_fit_general(topLeft, bottomRight, 40, 53, 273, 150)
end
 
sc_GetMoreMenuAnim = function(X, Y)
  return "0:x=" .. X .. ";y=" .. Y .. ";w=70;h=87|100:x=0;y=0;w=320;h=240|"
end
 
sc_SetSignalH = function(signal)
  local h = 85 * (float.new(signal) / 50)
  return h:toInt()
end
 
sc_SetSignalY = function(signal)
  local h = 85 * (float.new(signal) / 50)
  return 159 - h:toInt()
end
 
sc_SetSignalPos = function(listsize, width, cellw)
  local pos = 0
  pos = width / 2 - listsize * cellw / 2
  return pos
end
 
sc_PosRecalcLayer = function()
  local State = vActiveState()
  if State == "st_easyroutemenu" or State == "st_currenttraffic" then
    ui_RecalcMsgBox:X(82)
    ui_RecalcMsgBox:Y(3)
  elseif State == "st_myroutemenu" then
    ui_RecalcMsgBox:X(14)
    ui_RecalcMsgBox:Y(54)
  elseif State == "st_avoiditinerentry" then
    ui_RecalcMsgBox:X(69)
    ui_RecalcMsgBox:Y(97)
  elseif State == "st_routeitiner" or State == "st_routeparamswithwarnings_route" then
    ui_RecalcMsgBox:X(69)
    ui_RecalcMsgBox:Y(97)
  elseif State == "st_avoidancesmenu" then
    ui_RecalcMsgBox:X(87)
    ui_RecalcMsgBox:Y(106)
  elseif State == "st_historicalview" then
    ui_RecalcMsgBox:X(82)
    ui_RecalcMsgBox:Y(47)
  end
end
 
sc_SelectMapCursor = function()
  local CursorIcon = MODEL.map.primary.cursor_icon()
  if CursorIcon == "cursor_places" then
    return "ico_cursorhead_place.bmp"
  elseif CursorIcon == "cursor_poi" or CursorIcon == "cursor_poi_brand" then
    return ""
  elseif CursorIcon == "cursor_tmc" then
    return "ico_cursorhead_tmc.bmp"
  else
    return "ico_cursorhead_cursor.bmp"
  end
end
 
sc_fit_blockedroad = function()
  local topLeft, bottomRight = MODEL.mydata.blocked_roads.get_boundrect()
  sc_fit_general(topLeft, bottomRight, 48, 18, 264, 177)
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_fit_tracklog = function(topLeft, bottomRight, trackmode)
  if trackmode == 1 then
    MODEL.map.primary.center_posy = 65
    sc_fit_general(topLeft, bottomRight, 40, 73, 273, 172)
  else
    sc_fit_general(topLeft, bottomRight, 40, 53, 273, 152)
  end
end
 
sc_fit_itinerboxsize = function()
  local fit = MODEL.map.primary.fit
  fit.x = 36
  fit.y = 40
  fit.w = 120
  fit.h = 65
end
 
sc_OpenTrafficMapDetails = function()
  MODEL.lua.TrafficMapDetailsOpen = true
  ui_TrafficMapDetails:YBLEND(0, 43, 15)
  ui_EasyTMCMapControls:XBLEND(0, -47, 15)
  ui_rightcontrols_sublayer:YBLEND(60, 103, 15)
end
 
sc_CloseTrafficMapDetails = function()
  MODEL.lua.TrafficMapDetailsOpen = false
  ui_TrafficMapDetails:YBLEND(43, 0, 15)
  ui_EasyTMCMapControls:XBLEND(-47, 0, 15)
  ui_rightcontrols_sublayer:YBLEND(103, 60, 15)
end
 
sc_InstantCloseTrafficMapDetails = function()
  MODEL.lua.TrafficMapDetailsOpen = false
  ui_TrafficMapDetails:YBLEND(43, 0, 0)
  ui_EasyTMCMapControls:XBLEND(-47, 0, 0)
  ui_rightcontrols_sublayer:YBLEND(103, 60, 0)
end
 
sc_SetPictureSize = function()
  if MODEL.lua.pictloadhq() then
    spr_Pict:PICTW(2048)
    spr_Pict:PICTH(2048)
  else
    spr_Pict:PICTW(240)
    spr_Pict:PICTH(168)
  end
end
 
sc_SetFullScreenPictureSize = function()
  if MODEL.lua.pictloadhq() then
    spr_PictSlideShow:PICTW(2048)
    spr_PictSlideShow:PICTH(2048)
  else
    spr_PictSlideShow:PICTW(320)
    spr_PictSlideShow:PICTH(240)
  end
end
 
sc_SetSlideShowDemo = function()
  ui_PictSettings_SlideShowDemo.PictureW = 128
  ui_PictSettings_SlideShowDemo.PictureH = 186
end
 
sc_set_AdvMenuLayerPos = function()
  MODEL.lua.layerpos = 15
end
 
sc_GetLocalMenuBgY = function(size)
  local resultY = 141
  if size == 1 then
    resultY = 141
  elseif size == 2 then
    resultY = 87
  elseif size == 3 then
    resultY = 34
  end
  return resultY
end
 
sc_GetDemoTextH = function()
  ui_Demo_XHTML:W(308)
  ForceRefreshLayer(ui_Demo_XHTML)
  if MODEL.ui.ui_Demo_XHTML.can_scroll_up() or MODEL.ui.ui_Demo_XHTML.can_scroll_down() then
    ui_Demo_XHTML:W(280)
    ForceRefreshLayer(ui_Demo_XHTML)
  end
end
 
sc_ViaPositionSim = function(index)
  if MODEL.navigation.distance_total() > 0 then
    return (MODEL.navigation.distance_to_destination() - MODEL.INT.route.list.navigated.waypoints.list["@" .. index].total_length()) * 227 / MODEL.navigation.distance_total()
  end
  return -100
end
 
sc_ViaPosition = function(index)
  if index > 0 and index < MODEL.INT.route.list.navigated.waypoints.list.size() - 1 then
    return (MODEL.INT.route.list.navigated.waypoints.list["@last"].total_length() - MODEL.INT.route.list.navigated.waypoints.list["@" .. index].total_length()) * 227 / (MODEL.navigation.distance_to_destination() + MODEL.other.trips["@0"].distance_total())
  end
  return -100
end
 
sc_FitComparedRoutes = function(topLeft, bottomRight)
  if not topLeft:IsValid() or not bottomRight:IsValid() then
    return 
  end
  MODEL.map.primary.mode = "2d"
  MODEL.map.primary.fit.x = 53
  MODEL.map.primary.fit.y = 71
  MODEL.map.primary.fit.w = 153
  MODEL.map.primary.fit.h = 115
  local globe = MODEL.BOOL.map.primary.fit.globe_enabled()
  MODEL.BOOL.map.primary.fit.globe_enabled = true
  MODEL.map.primary.fit.show(topLeft, bottomRight)
  MODEL.BOOL.map.primary.fit.globe_enabled = globe
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_SetCountrySpecTMCIcon = function()
  local ID = MODEL.traffic.events.regionalize_icon(1000, MODEL.gps.position())
  gCountySpecTMCIcon = MODEL.screen.get_icon_file_and_phase(ID, 0)
  gCountySpecTMCIcon_Disabled = MODEL.screen.get_icon_file_and_phase(ID, 1)
end
 
sc_SetCockpitMap = function()
if MODEL.lua.CockpitType() == 2 then
    primary:X(88)
    primary:Y(0)
    primary:Z(0)
    primary:W(mapResW-88)
    primary:H(mapResH)
  else
    primary:X(0)
    primary:Y(0)
    primary:Z(0)
    primary:W(mapResW)
    primary:H(mapResH)
  end
end
 